<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include("./common_widget.php");
$params=$widget['option'];
$NodeId_or_GroupNodeId=array();
if(isset($params['nodeid']))
{
    foreach($params['nodeid'] as $val)
    {
        $NodeId_or_GroupNodeId[] = array('id'=>$val);
    }
}
elseif(isset($params['groupnodeid']))
{
    $arrid=array();
    foreach ($params['groupnodeid'] as $groupnode )
    {
        $arrid[] = $groupnode;
    }
    $tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$user->getId(),$arrid);
    foreach ($tab_group_node as $node)
    {
        $NodeId_or_GroupNodeId[] = array('id'=>$node->getId(),'parent'=>$node->getGroup(),'idgroup'=>$node->getGroupId());
    }
}
if($action =='update')
{
    if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
    {
        try
        {
            $widget = getPostDefaultParams($widget,$_POST);
            $params = $widget['option'];
            //Option des noeuds
            if(isset($params['nodeid']))
            {
                if($_POST['select_elem']!=null)
                {
                    $params['nodeid']=$_POST['select_elem'];
                }
                else
                {
                    $params['nodeid']=array();
                }
            }
            elseif(isset($params['groupnodeid']))
            {
                if($_POST['select_elem']!=null)
                {
                    $params['groupnodeid']=$_POST['select_elem'];
                }
                else
                {
                    $params['groupnodeid']=array();
                }
            }
            elseif(isset($params['pluginid']))
            {
                if($_POST['select_elem']!=null)
                {
                    $params['pluginid']=$_POST['select_elem'];
                }
                else
                {
                    $params['pluginid']=array();
                }
            }
            elseif(isset($params['service']))
            {
                if($_POST['services']!=null)
                {
                    $params['service']=$_POST['services'];
                }
                else
                {
                    $params['service']=array();
                }
            }
            if(isset($_POST['check_unknown']))
            {
                $params['show_unknown']='unknown';
                $params['show_pending']='pending';
            }
            else
            {
                $params['show_unknown']='none';
                $params['show_pending']='none';
            }
            if(isset($_POST['check_blink']))
            {
                $params['blink']='blink';
            }
            else
            {
                $params['blink']='none';
            }
            $params['type'] = $_POST['type'];
            $params['service_or_node'] = $_POST['service_or_node'];
            $params['all_service'] = $_POST['all_service'];
            $params['all_node'] = $_POST['all_node'];

            Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
            $smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
            $smarty->assign('widget',$widget);
            $smarty->assign('parameter',$params);
        }
        catch(Exception $e)
        {
            $smarty->assign('l_error',$e->getMessage());
        }
    }
    //recupération des styles
    $title = getWidgetStyle($params['title']['style'],14,'left','#575759');
    $description = getWidgetStyle($params['description']['style'],12,'left','#575759');
    $smarty->assign('titlestyle',$title);
    $smarty->assign('descriptionstyle',$description);
    $smarty->assign('type',$params['type']);
    $smarty->assign('service_or_node',$params['service_or_node']);
    $smarty->assign('all_node',$params['all_node']);
    $smarty->assign('all_service',$params['all_service']);
    if(empty($params['show_unknown']))
    {
        $params['show_unknown']='unknown';
        $params['show_pending']='pending';
    }
    $smarty->assign('check_pending',$params['show_pending']);
    $smarty->assign('check_unknown',$params['show_unknown']);

    $list=array();
  	if(isset($params['pluginid']))
    {
        //Récupération des plugins
        
        $plugins = Model_esia::getPlugin($dbconnection);
        $list=array();
        if(!empty($params['pluginid']))
        {
        	$smarty->assign('selected_plugin', $params['pluginid']);
        }
        else 
        {
        	$smarty->assign('selected_plugin',NULL);
        }
        foreach($plugins as $plugin)
        {
        	$list[$plugin['id']]=$plugin['name'];
        }
        $smarty->assign('descr',$lang['PLUGINS']);
        $smarty->assign('dash_list_select', $list);
    }
}
elseif($action =='getInfo')
{
	$errors = array();
	if($params['all_node']=='on' || $params['all_service']=='on')
	{
		$errs = Model_esia::getWidget4State($dbconnection,$user->getId(),$_GET['status']);
		$i = 0;
		foreach($errs as $err)
		{
			//print_r($err);
			$common_name = Model_esia::getCommonName($lang, $err['service_name'],$err['plugin_name']);
			$errors[]=array(array('common'=>$common_name,
							'device'=>$err['device_name'],
							'device'=>$err['device_name'],
							'message'=>$err['message'],
							'type'=>$err['type'] 
			));
			$i++;
		}
	}
	elseif(isset($params['pluginid']))
	{
		$listerr=array();
		$i = 0;
		foreach($params['pluginid'] as $plugin)
		{
			if($i >= 5)
			{
				break;
			}
			$arrerr = Model_esia::getPluginByCurrentState($dbconnection,$plugin,$_GET['status']);
			foreach($arrerr as $err)
			{
				if($i >= 5)
				{
					break;
				}
				$common_name = Model_esia::getCommonName($lang, $err['service'],$err['plugin_name']);
				$listerr[] = array('common'=>$common_name,
					'error'=>$err['type'],
									'type'=>$err['type'],
									'message'=>$err['message'],
									'device'=>$err['device_name'],
									'plugin_name'=>$err['plugin_name']
				);
				$i++;
			}
		}
		$errors[]= $listerr;
	}
	elseif(isset($params['service']))
	{
		$errors = array();
		$i = 0;
		foreach($params['service'] as $service)
		{
			if($i >= 5)
			{
				break;
			}
			$arrerr = model_esia::getServiceByCurrentState($dbconnection,$service,$_GET['status']);
			foreach($arrerr as $key => $err)
			{
				if($i >= 5)
				{
					break;
				}
				$common_name = Model_esia::getCommonName($lang, $err['service'],$err['plugin_name']);
				$arrerr[$key]["common"]= $common_name;
				$errors[$key][] = $arrerr[$key];
				$i++;
			}
		}
	}
	else
	{
		$i = 0;
		foreach($NodeId_or_GroupNodeId as $node)
		{
			if($i >= 5)
			{
				break;
			}
			$arrerr = model_esia::getNodeError($dbconnection,$node['id'],null,$_GET['status']);
			foreach($arrerr as $key => $err)
			{
				if($i >= 5)
				{
					break;
				}
				$common_name = Model_esia::getCommonName($lang, $err['service'],$err['plugin_name']);
				$arrerr[$key]["common"]= $common_name;
				$errors[$key][] = $arrerr[$key];
				$i++;
			}
		}
	}
    $serviceError=0;
    foreach($errors as $error)
    {
        foreach($error as $service)
        {
            $serviceError++;
        }
    }

    $smarty->assign('serviceError',$serviceError);
    $smarty->assign('errors',$errors);
}
elseif($action =='getInfoDonut')
{
    $errors = array();
    $nbr_error=0;
    $nbr_node=0;
    if($params['all_service']=='on')
    {
    	$arr = model_esia::countServiceAllState($dbconnection,$user->getId());
    	foreach($arr as $key => $item)
    	{
    		//echo strlower($key);
    		if($_GET['status'] == strtolower($key))
    		{
    			$errors[] = $item;
    		}
    	}
    }
    elseif($params['all_node']=='on')
    {
    	$arr = model_esia::countStateAllNode($dbconnection,$user->getId());
    	foreach($arr as $key => $item)
    	{
    		if($_GET['status'] == strtolower($key))
    		{
    			$errors[] = $item;
    		}
    	}
    }
    elseif(isset($params['pluginid']))
    {
    	$nbr=0;
        foreach($params['pluginid'] as $plugin)
        {
            $arrerr = Model_esia::getPluginByCurrentState($dbconnection,$plugin,$_GET['status']);
            $nbr = $nbr + count($arrerr);
        }
        
        $errors[] = $nbr;
    }
    elseif(isset($params['service']))
    {
    	$nbr=0;
        foreach($params['service'] as $service)
        {
            $arrerr = Model_esia::getServiceByCurrentState($dbconnection,$service,$_GET['status']);
            $nbr = $nbr + count($arrerr);
        }
        $errors[] = $nbr;
    }
    else
    {
    	$nbr=0;
        foreach($NodeId_or_GroupNodeId as $node)
        {
            $arrerr = Model_esia::getNodeError($dbconnection,$node['id'],null,$_GET['status']);
            $nbr = $nbr + count($arrerr);
        }
        $errors[] = $nbr;
    }
    $smarty->assign('errors',$errors);
}
else
{
    $state['ok']=0;
    $state["warning"]=0;
    $state["critical"]=0;
    $state["unknown"]=0;
    $state["pending"]=0;
    if($params['all_node']=='on')
    {
        $state = model_esia::countStateAllNode($dbconnection,$user->getId());
    }
    elseif ($params['all_service']=='on')
    {
        $arr = model_esia::countServiceAllState($dbconnection,$user->getId());
        $state['ok']=$arr['OK'];
        $state["warning"]=$arr['warning'];
        $state["critical"]=$arr['critical'];
        $state["unknown"]=$arr['unknown'];
        $state["pending"]=$arr['maintenance']+$arr['pending']+$arr['waiting'];
    }
    elseif(!empty($params['service']))
    {
        $state = model_esia::countServiceAllState($dbconnection,$user->getId(),$params['service']);
		$state['ok'] = $state['OK'];
    }
    elseif(!empty($params['nodeid']))
    {
        if($params['service_or_node']=='node') // En nombre de noeuds
        {
            $state = model_esia::countStateAllNode($dbconnection,$user->getId(),$params['nodeid']);
        }
        else // En nombre de services
        {
			if($params['nodeid'][0] == 1)
			{
				// Default dashboard check esia node but in some cases it can be moved to another id
				$params['nodeid'][0] = Model_esia::getEsiaSrvNodeId($dbconnection);
			}
			$state = Model_esia::countNodeState($dbconnection, $params['nodeid']);
			$state['ok'] = $state['OK'];
        }
    }
    elseif(!empty($NodeId_or_GroupNodeId))
    {
        $tab_id_nod = array();
        foreach($NodeId_or_GroupNodeId as $node)
        {
            $tab_id_nod[]=$node['id'];
        }

        if(!empty($tab_id_nod))
        {
            if($params['service_or_node']=='node') // En nombre de noeuds
            {
                $state = model_esia::countStateAllNode($dbconnection,$user->getId(),$tab_id_nod);
            }
            else
            {
                $state = model_esia::countNodeState($dbconnection,$tab_id_nod);
				$state['ok'] = $state['OK'];
            }
        }
        else
        {
            $smarty->assign('action','empty');
        }
    }
    elseif(!empty($params['pluginid']))
    {
        $state = model_esia::countServiceAllStateByPlugins($dbconnection,$params['pluginid'],$user->getId());
		$state['ok'] = $state['OK'];
    }
    else
    {
        $smarty->assign('action','empty');
    }
    $isempty=TRUE;
    foreach($state as $key => $value)
    {
    	if($value != 0 )
    	{
    		$isempty=FALSE;
    		break;
    	}
    }
    if( $isempty == TRUE)
    {
        $smarty->assign('action','empty');
    }
    else
    {
        $smarty->assign('state',$state);
    }
    $titlesize=0;
    //la taille du titre corrige les bugs sur le donut, pie et ring
    if(preg_match('#font\-size:([0-9]*)px;#',$params['title']['style'],$regs))
    {

        $titlesize = $regs[1];
        if($titlesize < 42)
        {
            $titlesize = 45;
        }
        //on augmente la hauteur du titre (20 = margin-bottom du titre de la widget + 5px du margin soit 30 )
        $titlesize = $titlesize +30;
    }
    widgetTranslateNameDescription($widget,$smarty,$lang);
    $smarty->assign('title_height',$titlesize);
    //BUG avec le donut, il ne se resize pas automatique
    if($params['type']=='donut' || $params['type']=='pie')
    {
        //on va rechercher le nombre de pixel de la tuile
        $tile = model_esia::getTiles($dbconnection,$widget['tile']);
        $tile = array_pop($tile);
        $descsize=0;
        //la taille de la description s'il y en a une
        if(!empty($widget['description']))
        {
            if(preg_match('#font\-size:([0-9]*)px;#',$params['description']['style'],$regs))
            {
                $descsize=$regs[1];
            }
        }
        $height = $tile['height']-$descsize-$titlesize;
        $smarty->assign('height',$height);
    }
}
$smarty->display($path.'/dashboard/template/view_4state.html');
?>
