<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include "./common_widget.php";
if(isset($_GET['type']))
{
	$smarty->assign('view_type',$_GET['type']);
}
if($action =='update')
{
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try
		{
		    $widget = getPostDefaultParams($widget,$_POST);
		    $params = $widget['option'];
			//Setter les filtres si définis
			foreach($_POST as $key => $var)
			{
			    if(preg_match('#([0-9a-zA-Z]*)\_filter#',$key, $regs))
			    {
			        if(!empty($_POST[$key]))
			        {
			            $params['filters'][$regs[1]] = $_POST[$key];
			        }
			        else
			        {
			            $params['filters'][$regs[1]] = "";
			        }
			    }
			}
			//Sélection des colonnes à afficher
			if(isset($_POST['widget_col_group']))
			{
			    $params['column']['group'] = 1;
			}
			else
			{
			    $params['column']['group'] = 0;
			}

			if(isset($_POST['widget_col_descr']))
			{
			    $params['column']['descr'] = 1;
			}
			else
			{
			    $params['column']['descr'] = 0;
			}
			if(isset($_POST['widget_col_ip']))
			{
			    $params['column']['ip'] = 1;
			}
			else
			{
			    $params['column']['ip'] = 0;
			}
			if(isset($_POST['input_col_msg']))
			{
			    $params['column']['message'] = 1;
			}
			else
			{
			    $params['column']['message'] = 0;
			}
			if(isset($_POST['input_col_date']))
			{
			    $params['column']['date'] = 1;
			}
			else
			{
			    $params['column']['date'] = 0;
			}
			if(isset($_POST['widget_hierarch']))
			{
				$params['hierarch'] = true;
			}
			else
			{
				$params['hierarch'] = false;
			}
			if(isset($_POST['input_col_action']))
			{
				$params['column']['action'] = 1;
			}
			else
			{
				$params['column']['action'] = 0;
			}
			if(isset($_POST['input_col_assign']))
			{
				$params['column']['assign'] = 1;
			}
			else
			{
				$params['column']['assign'] = 0;
			}
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$widget['option']=$params;
			$smarty->assign('widget',$widget);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	//echo '<pre>';print_r($widget);
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$params = $widget['option'];
	if(!isset($params['column']['group']))
	{
	    $params['column']['group']=1;
	}
	if(!isset($params['hierarch']))
	{
		$params['hierarch']=1;
	}
	$widget['option']['column']['group'] = $params['column']['group'];
	$widget['option']['hierarch'] = $params['hierarch'];
	$smarty->assign('widget',$widget);
	$smarty->display($path.'/dashboard/template/alert.html');
}
else
{
    	widgetTranslateNameDescription($widget,$smarty,$lang);
		$SIMPLEVIEW=true;
		$params = $widget['option'];
		$_GET['action']='dashboard';
		//colonne rajoutée
		if(!isset($params['column']['descr']) || $params['column']['descr']==0)
		{
		    $params['filters']['description']="";
		}
		if(!isset($params['column']['ip']) || $params['column']['ip']==0)
		{
		    $params['filters']['ip']="";
		}
		if(isset($params['column']['group'])&& $params['column']['group']==0)
		{
		    $params['filters']['group']="";
		}
		if(isset($params['column']['message'])&& $params['column']['message']==0)
		{
		    $params['filters']['message']="";
		}
		if(isset($params['column']['date'])&& $params['column']['date']==0)
		{
		    $params['filters']['date']="";
		}
		if(isset($params['column']['action'])&& $params['column']['action']==0)
		{
			$params['filters']['action']="";
		}
		if(isset($params['column']['assign'])&& $params['column']['assign']==0)
		{
			$params['filters']['assign']="";
		}
        if(!isset($params['hierarch']) || $params['hierarch'])
        {
            $_POST['hierarch']= 'true';
			$smarty->assign('hierarch','true');
		}
		else
		{
			$_POST['hierarch']='false';
			$smarty->assign('hierarch','false');
		}
		// ON fixe les filtres en variables POST pour l'envoit au système de tri du tablesorter
		foreach($params['filters'] as $key => $filt)
		{
		    if(isset($filt)&&!empty($filt))
		    {
		        $_POST[$key.'_filter']=$filt;
		    }
		    else
		    {
		        $_POST[$key.'_filter']="";
		    }
		}
		$_GET['widgetid']=$_GET['id'];
		$_GET['show_description'] = isset($params['column']['descr']) ? $params['column']['descr'] : '';
		$_GET['show_ip'] = isset($params['column']['ip']) ? $params['column']['ip'] : '';
		$_GET['show_group'] = isset($params['column']['group']) ? $params['column']['group'] : '';
		$_GET['show_message'] = isset($params['column']['message']) ? $params['column']['message'] : '';
		$_GET['show_date'] = isset($params['column']['date']) ? $params['column']['date'] : '';
		$_GET['show_action'] = isset($params['column']['action']) ? $params['column']['action'] : '';
		$_GET['show_assign'] = isset($params['column']['assign']) ? $params['column']['assign'] : '';
		$smarty->display($path.'/dashboard/template/alert.html');
		include $path.'/index.php';
}
?>
