<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
$webplugin_path = $_SERVER['DOCUMENT_ROOT'];
include "./common_widget.php";
require_once '/usr/local/esia/public_html/plugin/egidescan/model_egidescan.php';
require_once '/usr/local/esia/public_html/plugin/egidescan/libs/egide_common.libs.php';
// $smarty->assign('view_type',$_GET['type']);
if($action =='update')
{
	//Code permettant l'administration du bloc

	$parameters = $widget['option'];

	if(isset($parameters['nodeid']))
	{
		$nodes = Model_esia::getNodeList($dbconnection, $user->getId(), NULL, Model_esia::NODE_ASSOC);
		$nodesList = array();
		foreach($nodes as $node)
		{
			$selected = 'no';
			if(in_array($node['id'], $parameters['nodeid']))
			{
				$selected = 'yes';
			}

			$nodesList[] = array('id' => $node['id'], 'name' => $node['name'], 'selected' => $selected);
		}
		$smarty->assign('adm_list_node', $nodesList);
	}
	elseif(isset($parameters['groupnodeid']))
	{
		$list = Model_esia::getNodeGroupHierarchyByUser($dbconnection,$user->getId());
		$list_group_node=array();
		foreach($list as $node)
		{
			$selected='no';
			if(in_array($node['id'],$parameters['groupnodeid']))
			{
				$selected='yes';
			}

			$list_group_node[]=array('id'=>$node['id'],
				'name'=>$node['name'],
				'selected'=>$selected);
		}
		$smarty->assign('adm_list_group_node', $list_group_node);
	}

	$parameters = $widget['option'];

	$smarty->assign('param',$parameters);
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		//on traite le formulaire
		try
		{
			//traite les données post pour le style du titre et de la description
			$widget = getPostDefaultParams($widget,$_POST);
			$parameters = $widget['option'];

			if(isset($parameters['nodeid']))
			{
				$parameters['nodeid']=$_POST['nodes'];
			}
			elseif(isset($parameters['groupnodeid']))
			{
				$parameters['groupnodeid']=$_POST['groupnodes'];
			}

			//traitement des variable POST

			Model_esia::updateWidget($dbconnection,$widget['id'], $widget['name'], $widget['description'], $widget['during'], $parameters);
			//la variable l_success est affichée en rouge dans le smarty
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
		}
		catch (EsiaDbException $e)
		{
			//la variable l_error est affichée en rouge dans le smarty
			$smarty->assign('l_error',$e->getMessage());
		}
		catch (Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	//récupération des styles:
	//recupération des styles
	$title = $parameters['title']['style'];
	$description = $parameters['description']['style'];
	$title = getWidgetStyle($title,14,'left','#575759');
	$description = getWidgetStyle($description,12,'left','#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('path_widg',$widget['path']);
	//récupération des données pour l'affichage
	//on fixe le mode update
	$smarty->assign('action','update');
}


//chemin d'accès au template de votre block

else
{
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

	$parameters = $widget['option'];
	$userid = $user->getId();

	if(isset($parameters['nodeid']))
	{
		$nodeList = $parameters['nodeid'] ;
	}
	elseif(isset($parameters['groupnodeid']))
	{
		$tab_group_node = Model_esia::getAllNodeofGroup($dbconnection,$userid,$parameters['groupnodeid']);
		foreach ($tab_group_node as $node)
		{
			$nodeList[] = $node->getId();
		}
	}

	if(!empty($nodeList))
	{
		$severityChartData = Model_egidescan::getNumberGlobalByScoringChartColumn($dbconnection, $userid, $nodeList);
		$complexityCount = Model_egidescan::getNodeComplexityCountsByIface($dbconnection, $userid, $nodeList);
	}
	else
	{
		$scoringCounts = array(
			'0 - 1' => 0,
			'1 - 2' => 0,
			'2 - 3' => 0,
			'3 - 4' => 0,
			'4 - 5' => 0,
			'5 - 6' => 0,
			'6 - 7' => 0,
			'7 - 8' => 0,
			'8 - 9' => 0,
			'9 - 10' => 0,
		);
		$severityChartData = array(
			'x' => array_keys($scoringCounts),
			'y' => array_values($scoringCounts),
		);
		$complexityCount = array(
			'LOW' => 0,
			'MEDIUM' => 0,
			'HIGH' => 0,
			'CRITICAL' => 0,
		);
	}
	$smarty->assign('severityChartData', $severityChartData);
	$smarty->assign('complexityCount', $complexityCount);

	$smarty->assign('widget_id',$widget['id']);
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
}
$smarty->display($webplugin_path.'dashboard/template/egidescan_severity.html');
?>
