<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include("./common_widget.php");

$params=$widget['option'];
if($action =='update')
{
	if($params['type']=='abr' || empty($params['type']))
	{
		$params['type']='abre';
	}
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{
		try
		{
			$widget = getPostDefaultParams($widget,$_POST);
			$params = $widget['option'];
			$arr = array();
			if($_POST['select_elem']!=null)
			{
				$arr= $_POST['select_elem'];
			}
			if(isset($_POST['services']))
			{
				$arr= $_POST['services'];
			}
			if(isset($params['nodeid']))
			{
				$params['nodeid']=$arr;
			}
			elseif(isset($params['groupnodeid']))
			{
				$params['groupnodeid']=$arr;
			}
			elseif(isset($params['pluginid']))
			{
				$params['pluginid']=$arr;
			}
			elseif(isset($params['service']))
			{
				$params['service']=$arr;
			}

			if(isset($_POST['check_blink']))
			{
				$params['blink']='blink';
			}
			else
			{
				$params['blink']='none';
			}
			$params['type'] = $_POST['type'];
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$widget['name']=$_POST['widgetname'];
			$widget['description']=$_POST['widgetdescription'];
			$smarty->assign('widget',$widget);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('type',$params['type']);
	$smarty->assign('parameter',$params);
	$listSelect=array();
	if(isset($params['pluginid']))
	{
		//Récupération des plugins
		$plugins = Model_esia::getPlugin($dbconnection);
		$list=array();
		if(!empty($params['pluginid']))
		{
			$smarty->assign('selected_plugin', $params['pluginid']);
		}
		else
		{
			$smarty->assign('selected_plugin',NULL);
		}
		foreach($plugins as $plugin)
		{
			$list[$plugin['id']]=$plugin['name'];
		}
		$smarty->assign('descr',$lang['PLUGINS']);
		$smarty->assign('dash_list_select', $list);
	}
}
else
{
	if(!isset($params['blink']))
	{
		$params['blink'] = 'none';
	}
	$smarty->assign('parameter',$params);
	//Affichage
	$state['OK']=0;
	$state["warning"]=0;
	$state["critical"]=0;
	$state["unknown"]=0;
	$state["pending"]=0;
	if(!empty($params['service']))
	{
		$state = model_esia::countServiceAllState($dbconnection,$user->getId(),$params['service']);
	}
	elseif(!empty($params['nodeid']))
	{
		$state = model_esia::countNodeState($dbconnection,$params['nodeid']);
	}
	elseif(!empty($params['groupnodeid']))
	{
		$groups_node = Model_esia::getAllNodeofGroup($dbconnection,$user->getId(),$params['groupnodeid']);
		$arr = array();
		foreach ($groups_node as $node)
		{
			$arr[] = $node->getId();
		}
		if(!empty($arr))
		{
			$state = model_esia::countNodeState($dbconnection,$arr);
		}
		else
		{
			$smarty->assign('action','empty');
		}
	}
	elseif(!empty($params['pluginid']))
	{
		$state = model_esia::countServiceAllStateByPlugins($dbconnection,$params['pluginid'],$user->getId());
	}
	else
	{
		$smarty->assign('action','empty');
	}
	$globalstate="EMPTY";
	if(!empty($state))
	{
		if($state['critical'] > 0)
		{
			$globalstate='critical';
		}
		elseif($state['warning'] > 0)
		{
			$globalstate='warning';
		}
		elseif($state['unknown'] > 0)
		{
			$globalstate='unknown';
		}
		elseif($state['OK'] > 0)
		{
			$globalstate='OK';
		}
		elseif($state['pending'] > 0)
		{
			$globalstate='pending';
		}
	}
	$smarty->assign('globalstate',$globalstate);
}
$smarty->display($path.'/dashboard/template/view_flag_state.html');
?>
