<?php
/*DESCRIPTION: inclus les variables habituelles pour la gestion d'une widget et vérifie les droits d'accès
 *APRES l'inclusion du common_widget les variables suivantes sont créées:
 *PHP:
 *      $action l'action passé dans l'url ou 'view'
 *      $widget un tableau associatif reprenant les paramètre de la widget
 * SMARTY
 *      $widget les informations de la widget
 *      $parameter les parametre de la widget (JSON)
 *      $action l'action passé dans l'url ou 'view'
 */
include("./common_widget.php");

$arr = Model_esia::getWebPlugin($dbconnection,false,'WEBP_IPAM');
$plugin_url = $arr[0]['apache_path'];
$index_page = $arr[0]['index_page'];

include_once $path.$plugin_url.'model_ipam.php';

$params=$widget['option'];
if($action =='update')
{
	if($params['type']=='table' || empty($params['type']))
	{
		$params['type']='table';
	}
	if(isset($_POST['widgetid'])&&!empty($_POST['widgetid']))
	{

		try
		{
			$widget = getPostDefaultParams($widget,$_POST);
			$params = $widget['option'];
			if( isset($_POST['all_select']) && ($_POST['all_select'] == 'all'))
			{
				$params['networks']= 'all';
			}
			elseif(!empty(($_POST['networks'])))
			{
				$params['networks']= $_POST['networks'];
			}
			$params['type'] = $_POST['type'];
			Model_esia::updateWidget($dbconnection, $widget['id'], $widget['name'], $widget['description'], $widget['during'], $params);
			$smarty->assign('l_success',$lang['UPDATE_DASHBOARD_SUCCESS']);
			$widget['name']=$_POST['widgetname'];
			$widget['description']=$_POST['widgetdescription'];
			$smarty->assign('widget',$widget);
		}
		catch(Exception $e)
		{
			$smarty->assign('l_error',$e->getMessage());
		}
	}
	//recupération des styles
	$title = getWidgetStyle($params['title']['style'],14,'left','#575759');
	$description = getWidgetStyle($params['description']['style'],12,'#575759');
	$smarty->assign('titlestyle',$title);
	$smarty->assign('descriptionstyle',$description);
	$smarty->assign('type',$params['type']);
	$smarty->assign('parameter',$params);

	$sources_list = Model_ipam::getDeviceSourceList($dbconnection,$user);
	$withNetworkSources = array();
	foreach($sources_list as $source)
	{
		if( $source['network_nb'] > 0)
		{
			if(empty($source['gesa_sn']))
			{
				$networks = Model_ipam::getNetworksList($dbconnection,'this',$user);
			}
			else
			{
				$networks = Model_ipam::getNetworksList($dbconnection,$source['device_id'],$user);
			}
			$withNetworkSources[$source['device_name']] = array();
			foreach($networks as $net)
			{
				$withNetworkSources[$source['device_name']][$net['net_id']] = $net['name'];
			}
		}
	}

	$smarty->assign('networks_list',$withNetworkSources);
	if( !isset($params['networks']) )
	{
		$params['networks'] = 'all';
	}


	if( $params['networks'] == 'all' )
	{
		$smarty->assign('selected','all');
	}
	else
	{
		$smarty->assign('selected','select');
		$smarty->assign('selected_networks',$params['networks']);
	}
}
else
{
	$networks = array();
	$limit = 10;
	$ignore_dhcp = TRUE;
	$ignore_reserved = TRUE;
	if( $params['networks'] == 'all' )
	{
		$addr_lists = Model_ipam::getBusyAddresses($dbconnection,NULL,$ignore_dhcp,$ignore_reserved,$limit);
	}
	elseif( !empty($params['networks']) && is_array($params['networks']))
	{
		$addr_lists = Model_ipam::getBusyAddresses($dbconnection,$params['networks'],$ignore_dhcp,$ignore_reserved,$limit);
	}

	$busy_addr['busy'] = array();
	$busy_addr['reserved'] = array();
	$busy_addr['dhcp'] = array();
	foreach($addr_lists as $addr)
	{
		if( $addr['reserved_type'] == 'busy' )
		{
			$addr['descr'] = $lang['IPAM_ADD_NODE_ADVISE'];
		}
		elseif( $addr['reserved_type'] == 'reserved' )
		{
			$addr['descr'] = $addr['reserved_name']. ' by '.$addr['reserved_user'];
		}
		else
		{
			$addr['descr'] = 'DHCP';
		}
		$busy_addr[$addr['reserved_type']][] = $addr;
	}
	$busy_addr = array_merge($busy_addr['busy'],$busy_addr['reserved'],$busy_addr['dhcp']);
	if( count($busy_addr) < $limit)
	{
		$busy_addr[] = array('reserved_type'=>'end','descr'=>$lang['IPAM_BUSY_END_LIST']);
	}

	$smarty->assign('busy_addr',$busy_addr);
}
$smarty->assign('apache_path',$plugin_url);
$smarty->display($path.'/dashboard/template/view_ipam_node.html');
?>
