<?php
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include_once $path.'/esia.conf.php';
include_once USR_CLASS;
include_once MVCMODEL;
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
	session_start();
	$user = new User($dbconnection);
	$user->sessionIDisValid(Model_esia::getDuringSession($dbconnection));
}
catch(UserException $e)	//Il n'est pas connecté
{
    session_write_close();
    echo json_encode(array('ERROR'=> 'User not connected'));
    exit(0);
}
catch(Exception $e)
{
    echo json_encode(array('ERROR'=>  'PDO CONNECTION ERROR: '.$e->getMessage()));
    exit(0);
}
//mise en place des fichier de langue
$lang_abre =LANG;
if($user->getLang()!="")
{
	//configuration de la langue de l'application
	$lang_abre = $user->getLang();
}
$lang_path = $path.'/lang/'.$lang_abre.'/';
if(file_exists($lang_path.$lang_abre.'.php'))
{
	include $path.'/lang/'.$lang_abre.'/'.$lang_abre.'.php';
}
if(file_exists($lang_path.'/common_plugin_name.php'))
{
	include $lang_path.'/common_plugin_name.php';
}
?>
