<?php

$path = $_SERVER['DOCUMENT_ROOT'];
$ESIA_WIDGET_NOTREE = TRUE;
include_once $path . '/common.php';
include_once $path . '/model_tablesort.php';

// Gestion du table sorter
$params = array(
    'filters' => $_REQUEST['filters'],
	'order' => $_REQUEST['cols'],
	'size' => 50,
	'paging'=> 0,
);
if(isset($_GET['page']) && !empty($_GET['page']))
{
	$params['paging'] = $_GET['page'];
}
if(isset($_GET['size']) && !empty($_GET['size']))
{
	if($_GET['size'] == 'all')
	{
		$_GET['size'] = 100;
	}
	$params['size'] = $_GET['size'];
}

//Gestion des langues du système / utilisateur pour les données traduite.
$lang_abre = LANG;
if($user->getLang() != "")
{
	//configuration de la langue de l'application
	$lang_abre = $user->getLang();
}
if(file_exists($path . '/lang/' . $lang_abre . '.php'))
{
	include $path . '/lang/' . $lang_abre . '.php';
}

$action = '';
if(!empty($_REQUEST['action']))
{
	$action = $_REQUEST['action'];
}

try
{
	if($action == 'listDeviceNotes')
	{
		if(empty($_GET['id']) || !is_numeric($_GET['id']))
		{
			throw new Exception("Missing node id");
		}
		$dbData = Model_TableSort::ts_getDeviceNotes($dbconnection, $_GET['id'], $params);

		// Define table columns
		$columns = array(
			0 => $lang['SUBJECT'],
			1 => $lang['NODE_NOTE'],
			2 => $lang['TYPE'],
			3 => $lang['NODE_NOTE_USER'],
			4 => $lang['CREATE_DATE'],
			5 => $lang['LAST_MODIFY'],
			6 => $lang['NODE_NOTE_PURGE'],
			7 => $lang['ACTION'],
		);

		// Create table rows
		$rows = array();
		foreach($dbData['rows'] as $note)
		{
			// Cell purge
			if(empty($note['note_auto_purge']))
			{
				$cellPurge = '<img src="/theme/default/images/refuse.png" alt="' . $lang['DISABLED'] . '" title="' . $lang['DISABLED'] . '" width=24>';
			}
			else
			{
				$cellPurge = '<img src="/theme/default/images/accept.png" alt="' . $lang['ENABLED'] . '" title="' . $lang['ENABLED'] . '" width=24>';
			}
			
			// Create actions cell
			if($user->getDroits($dbconnection, 'device_notes_administration') >= 1)
			{
				$noteUpdUrl = '/node_notes.php?action=updateNote&id=' . $_GET['id'] . '&noteId=' . $note['note_id'];
				$noteDelUrl = '/node_notes.php?action=deleteNote&id=' . $_GET['id'] . '&noteId=' . $note['note_id'];
				$cellActions = '<td class="alignCenterTab actions-cell">' .
					'<a class="btnImg" href="' . $noteUpdUrl . '" title="' . $lang['MODIF'] . '" onclick="ajaxTsOpenActionsDialog(this); return false;">' .
						'<img class="button" src="/theme/default-image/esia_update_button2.png" alt="' . $lang['MODIF'] . '"/>' .
					'</a>' .
					'<a class="btnImg" href="' . $noteDelUrl . '" title="' . $lang['DELETE'] . '" onclick="ajaxTsOpenActionsDialog(this, 800, 500); return false;">' .
						'<img class="button" src="/theme/default-image/esia_delete_button.png" alt="' . $lang['DELETE'] . '"/>' .
					'</a>' .
				'</td>';
			}
			else
			{
				$cellActions = '<td></td>';
			}

			// Set HTML links
			$noteMessage = preg_replace('@(https?://([-\w\.]+[-\w])+(:\d+)?(/([\w/_\.#-]*(\?\S+)?[^\.\s])?)?)@', '<a href="$1">$1</a>', $note['note_message']);

			// Thread type from $lang
			$langKey = 'NODE_NOTE_THREAD_TYPE_' . $note['thread_type'];
			if(isset($lang[$langKey]))
			{
				$note['thread_type'] = $lang[$langKey];
			}

			$rows[] = array(
				$columns[0] => $note['thread_title'],
				$columns[1] => '<td><p class="noteMessage">' . $noteMessage . '</p></td>',
				$columns[2] => $note['thread_type'],
				$columns[3] => $note['note_user_name'],
				$columns[4] => $note['note_date'],
				$columns[5] => $note['note_last_update'],
				$columns[6] => '<td class="alignCenterTab">' . $cellPurge . '</td>',
				$columns[7] => $cellActions,
			);
		}

		echo json_encode(array(
			'headers' => $columns,
			'rows' => $rows,
			'total_rows' => $dbData['total'],
		));
	}
}
catch(EsiaDbException | Exception $e)
{
	echo json_encode($e->getMessage());
}
?>
