<?php
/**
 * Esia UI smarty_function_eui_forms_selectNodes
 * @author Nicolas Biersart
 * @param array $params un tableau associatif contenant les paramètres passé à la fonction
 * 				'id' string identifiant JS
 *   			'name' string (optionnel) Nom HTML du select
 *   			'firstValue' si spécifié indique la première valeur de l'option
 *   			'firstText' si spécifié indique le premièr texte de l'option
 *				'value' array tableau contenant les valeurs option du select. 2 formats peuvent être passé
 *							le premier est un tableau clé => valeur. la clé étant l'attribut value de l'option et la valeur l'attribut texte
 * 							la deuxieme est un tableau associatif avec les clés 'id' et les clé 'name'. id étant l'attribut value de l'option et name l'attribut texte
 *   			'class' string (optionnel) classe CSS du select
 *   			'style' string (optionnel) attribut style
 *   			'onchange' string (optionnel) fonction JS appelé lors d'un changement
 *   			'other' string (optionnel) permet de fixer d'autre attribut HTML
 * 				'label' string (optionnel) texte du label associé au select
 * 				'labelclass' string (optionnel) la classe CSS associé au label
 * 				'labelstyle' string (optionnel) attribut style du label
 *   			'onclick' string (optionnel) fonction JS appelé si on clique sur le label
 *   			'placeholder' string (optionnel) indique le texte du placeHolder
 *   			'keepopen' string (optionnel) si présent et que c'est un select multiple, garde la liste de selection ouverte tant qu'on clique dedans
 * @param Smarty_Internal_Template $template template object
 * @return string   la sortie au format HTML.
 * @uses ui_forms_select
 */
function smarty_function_eui_forms_selectGroups($params, $template)
{
	$template->_checkPlugins(
		array(
			array(
				'function' => 'smarty_function_eui_forms_select',
				'file'     => RACINE_SITE . '/libs/smarty-plugins/esia/function.eui_forms_select.php'
			)
		)
		);
	$output="";
	$name = $params['name'];
	$l_group = "";
	if(array_key_exists('label_group',$params))
	{
		$l_group = $params['label_group'];
	}
	else
	{
		$lan = $template->getTemplateVars('lang');
		if(array_key_exists('DASHBOARD_SELECT_GROUP_NODE',$lan))
		{
			$l_group = $lan['DASHBOARD_SELECT_GROUP_NODE'];
		}
		else 
		{
			$l_group = 'Not variable lang found'; 
		}
	}
	$inputClass= 'class="'.$params['class'].'"';
	$selected=NULL;
	if(!empty($params['selected']))
	{
		$selected = $params['selected'];
	}
	$grp_node['id']=$params['id'];
	$grp_node['class']=$params['class'];
	$grp_node['name']=$params['name'];
	$grp_node['label']=$l_group;
	$grp_node['jsLoadFunction']="eui_forms.loadGroup('".$params['id']."',".json_encode( $selected,true).");";
	if(array_key_exists('onchange',$params))
	{
		$grp_node['onchange']=$params['onchange'];
	}
	if(array_key_exists('keepopen', $params))
	{
		$grp_node['keepopen'] = $params['keepopen'];
	}
	$output .= smarty_function_eui_forms_select($grp_node, $template);
	return $output;
}
?>
