<?php
/**
 * Esia UI forms_select
 * @author Nicolas Biersart
 * @param array $params un tableau associatif contenant les paramètres passé à la fonction
 * 				'id' string identifiant JS
 *   			'name' string (optionnel) Nom HTML du select
 *     			'multiple' boolean si spécifié passe le select en multiple
 *     			'ajax' string URI spécifié l'URL pour charger le select en ajax avec du JSON. Voir setData sur le site https://slimselectjs.com
 *   			'firstValue' si spécifié indique la première valeur de l'option
 *   			'firstText' si spécifié indique le premièr texte de l'option
 *				'value' array tableau contenant les valeurs option du select. 2 formats peuvent être passé
 *							le premier est un tableau clé => valeur. la clé étant l'attribut value de l'option et la valeur l'attribut texte
 * 							la deuxieme est un tableau associatif avec les clés 'id' et les clé 'name'. id étant l'attribut value de l'option et name l'attribut texte
 *   			'class' string (optionnel) classe CSS du select
 *   			'style' string (optionnel) attribut style
 *   			'onchange' string (optionnel) fonction JS appelé lors d'un changement
 *   			'other' string (optionnel) permet de fixer d'autre attribut HTML
 * 				'label' string (optionnel) texte du label associé au select
 * 				'labelclass' string (optionnel) la classe CSS associé au label
 * 				'labelstyle' string (optionnel) attribut style du label
 *   			'onclick' string (optionnel) fonction JS appelé si on clique sur le label
 *   			'placeholder' string (optionnel) indique le texte du placeHolder
 *   			'disable' string (optionnel) indique le texte du placeHolder
 * @param Smarty_Internal_Template $template template object
 * @return string   la sortie au format HTML.
 * @uses ui_forms_select
 */
function smarty_function_eui_forms_selectTimezone($params, $template)
{
	$template->_checkPlugins(
		array(
			array(
				'function' => 'smarty_function_eui_forms_select',
				'file'     => RACINE_SITE . '/libs/smarty-plugins/esia/function.eui_forms_select.php'
			)
		)
		);
	$par = $params;
	$output='';
	$timezone_identifiers = DateTimeZone::listIdentifiers();
	$arr=array();
	foreach ($timezone_identifiers as $zone)
	{
		$arr[$zone]=$zone;
	}
	$par['value']=$arr;
	$output .= smarty_function_eui_forms_select($par, $template);
	return $output;
}

?>
