<?php
/**
 * Esia UI forms_toggle_switch
 * @author Julien George
 * @param array $params un tableau associatif contenant les paramètres passé à la fonction
 * 				'id' string (Requis) ID Html/CSS à ajouter à l'élément parent.
 *   			'name' string (Requis) Doit être unique par formulaire. Ce sera le nom de la propriété _GET ou _POST
 *     			'selected' (Optionnel) Correspond à la valeur actuellement sélectionnée.
 *   			'class' string (optionnel) class CSS du select à ajouter à l'élement parant qui contient déjà eui-toggle-switch
 *   			'[left|right]-label' : Nom affiché par le bouton (droite ou gauche). Option remplacé par le tableau data
 *   			'[left|right]-value' : Valeur du le bouton (droite ou gauche). Option remplacé par le tableau data
 *				'data' array tableau contenant les valeurs et label du toggle-switch.Ce tableau contient une liste de tableau avec 2 clés/valeurs :
 *							label : Nom affiché par le bouton
 *                          value : Valeur envoyé par le bouton
 * @param Smarty_Internal_Template $template template object
 * @return string   la sortie au format HTML.
 * @uses ui_forms_select
 */
function smarty_function_eui_forms_toggle_switch($params, $template)
{
    //Evite une erreur html
    if( !isset($params['selected']))
    {
        $params['selected'] = '';
    }

    if( empty( $params['data'] ))
    {
        $params['data'] = array();
        $row['label'] = $params['left-label'];
        $row['value'] = $params['left-value'];
        $params['data'][] = $row;
        $row['label'] = $params['right-label'];
        $row['value'] = $params['right-value'];
        $params['data'][] = $row;
    }

    if (empty($params['data']))
    {
        trigger_error("eui_forms_toggle_switch: missing or empty 'data' parameter", E_USER_WARNING);
        return;
    }

    $classes = 'eui-toggle-switch';
    if( isset($params['class']))
    {
        $classes .= ' '.$params['class'];
    }

    echo '<div style="display: flex; flex-direction:column;"><fieldset id="'.$params['id'].'" class="'.$classes.'">'."\n";
	$output = '';
    foreach($params['data'] as $key => $row)
    {
        $input_id = 'radio_'.$params['id'].'_'.$key;
        if( $row['value'] == $params['selected'] )
        {
            $output.= '<input id="'.$input_id.'" name="'.$params['name'].'" type="radio" value="'.$row['value'].'" checked>'."\n";
        }
        else
        {
            $output.= '<input id="'.$input_id.'" name="'.$params['name'].'" type="radio" value="'.$row['value'].'">'."\n";
        }
        $output.= '<label for="'.$input_id.'">'.$row['label'].'</label>'."\n";
    }
    $output.= '</fieldset></div>'."\n";
    return $output;
}
