<?php
/**
 * @name utils.lib.php
 * @description Librairie proposant des fonctions utilisables partout en PHP
 * @author Quentin George <q.george@esia-sa.com>
 * @date 10/01/2024
 */

// Namespace pour les fonctions concernant les variables de langue
namespace Utils\Lang
{
    /**
	 * Vérifie si une string sauvegardée en DB correspond a une clée de variable de langue et récupère le text de la langue
	 * @param array $lang référence variable de langue
	 * @param integer $dbString text sur lequel vérifié la correspondance dans les variables de langue
	 * @retval string text initial ou text de traduction trouvé
	 */
    function checkDBLangKey(&$lang, $dbString)
    {
        $dbString = trim($dbString);
        if(strpos($dbString, 'LANG_') === 0)
        {
            // If the string beggin by LANG_ remove it and use the string as lang key
            $key = substr($dbString, 5);
            if(isset($lang[$key]))
            {
                $dbString = $lang[$key];
            }
        }

        return $dbString;
    }
}

?>
