<?php
/**
 * @name login.php
 * @description page d'authentification et de déconnexion des utilisateurs
 * @author Nicolas Biersart <n.biersart@esia-network.com>
 * @contributor
 * @copyright Nicolas Biersart 2012
 * @license
 * @esia 1.00
 * @version 1.0.0
 * @date 16/04/2013
 */
//include_once 'common.php';
$path = rtrim ($_SERVER['DOCUMENT_ROOT'],'/');
include $path.'/esia.conf.php';
include_once USR_CLASS;
include_once LIB_LOG;
include_once MVCMODEL;
include_once MVCMODEL_ADM;
require_once(SMARTY_DIR . 'Smarty.class.php');
//connection à la base de donnée
try
{
	$dbconnection = new PDO('pgsql:host='.DB_HOST.';port='.DB_PORT.';dbname='.DB_NAME, DB_USERNAME, DB_PWD);
	$dbconnection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_WARNING);
}
catch(Exception $e)
{
	echo 'PDO SQL ERROR: '.$e->getMessage().'<br />';
	echo 'N° : '.$e->getCode();
}
session_start();
$smarty = new Smarty();
//configuration de la langue de l'application
include $path.'/lang/'.LANG.'/'.LANG.'.php';

//configuration moteur template
$theme = Model_esia::getApplicationTheme($dbconnection);
$smarty->template_dir = $path.'/theme/'.$theme.'/template/';
$smarty->compile_dir = $path.'/theme/'.$theme.'/templates_c/';
$smarty->config_dir = $path.'/configs/';
$smarty->cache_dir = $path.'/cache/';
$smarty->assign('css', '/theme/'.$theme.'/design.css');
$smarty->assign('lang', $lang);
$smarty->assign('title','Esia Network Management');
$smarty->assign('l_login', $lang['LOGIN']);
$smarty->assign('l_password', $lang['PASSWORD']);
$smarty->assign('l_connection', $lang['CONNECTION']);
$banner = Model_esia::getConfiguration($dbconnection,'DEFAULT_BANNER');
$smarty->assign('banner_path',$banner['DEFAULT_BANNER']['value']);
$bannerFond = Model_esia::getConfiguration($dbconnection,'DEFAULT_BANNER_FONTCOLOR');
$smarty->assign('bannerFond',$bannerFond['DEFAULT_BANNER_FONTCOLOR']['value']);
//on veut se déconnecter
if(isset($_GET['log'])&&!empty($_GET['log'])&&$_GET['log']=='logout')
{
	$user = new User($dbconnection);
	$user->disconnect();
}
else
{
	//on tente de se connecter
	if(isset($_POST['username'])&&!empty($_POST['username'])&&isset($_POST['password'])&&!empty($_POST['password']))
	{
		try
		{
			$ldapserver = Model_esia::getConfiguration($dbconnection,'LDAP_HOST_URI');
	        $user = new User($dbconnection);
	        $flagauth=false;
	        $login = $_POST['username'];
	        $ldap_account=false;
	        if(preg_match('#(.*)@#',$login,$regs))
	        {
	        	$login=$regs[1];
	        	$ldap_account=true;
	        }
	        else
	        {
	        	if(preg_match('#\\\(.*)$#',$login,$regs))
	        	{
	        		$login=$regs[1];
	        		$ldap_account=true;
	        	}
	        }
	        
	        if(!empty($ldapserver['LDAP_HOST_URI']['value']) && function_exists('ldap_bind')&& $ldap_account==true)
	        {
	             //connexion à lDAP
	        	ldap_set_option(NULL, LDAP_OPT_DEBUG_LEVEL, 7);
				$ds=ldap_connect($ldapserver['LDAP_HOST_URI']['value']);
				ldap_set_option($ds, LDAP_OPT_REFERRALS, 0);
				ldap_set_option($ds, LDAP_OPT_PROTOCOL_VERSION, 3);
				//ldap_start_tls($ds);
	            if($ds)
	            {
	                //test d'authentification
	                $result=ldap_bind($ds,$_POST['username'],$_POST['password']);
	                if($result !==FALSE)
					{
						//authentification LDAP reussie on prend le login et on vérifie que l'utilisateur à le droit d'accéder à LDAP
						$usertemp = Model_esia::InstanceUser($dbconnection, $login);
						$base = Model_esia::getConfiguration($dbconnection,'LDAP_BASEDN');
						$group = Model_esia::getConfiguration($dbconnection,'LDAP_MEMBER_GROUPS_MATCH');
						$ldap_group = $group['LDAP_MEMBER_GROUPS_MATCH']['value'];
						$ldap_group = json_decode($ldap_group,TRUE);
						$arr_attribute=array('samaccountname','Mail','email','mail','userprincipalname');
						foreach($ldap_group as $corr)
						{
							$arr_attribute[] = $corr['attribute'];
						}
						$filter = "(|(sn=$login)(cn=$login)(givenname=$login)(sAMAccountName=$login)(samaccountname=$login))";
						$data = ldap_search($ds,$base['LDAP_BASEDN']['value'],$filter,$arr_attribute);
						$info = ldap_get_entries($ds, $data);
						$info = $info[0];
						if(!empty($info))
						{
							//Utilisateur trouvé on regarde si les attribus (exemple memberof est OK)
							if($group['LDAP_MEMBER_GROUPS_MATCH']['value'] !='')
							{

								$groups_esia_member=array();
								foreach($ldap_group as $corr)
								{
									$esia_group = $corr['esia_groups'];
									$attribute = $corr['attribute'];
									$match  = $corr['match'];
									foreach($info[$attribute] as $member)
									{
										if(stripos($member,$match)!==FALSE)
										{
											$found = Model_adm::getGroup($dbconnection,$esia_group);
											if(!empty($found))
											{
												$found = array_shift($found);
												if(!in_array($found['id'],$groups_esia_member))
												{
													$groups_esia_member[]=$found['id'];
												}
											}
										}
									}
								}
								//Si $groups_esia_member est vide, il n'y a pas de correspondance d'accès. Donc pas autorisé à se connecter
								// vérifier la correspondance entre les groupes du json LDAP_MEMBER_GROUPS_MATCH de la talbe esia_configuration
								if(!empty($groups_esia_member))
								{
									//On vérifie si l'utilisateur existe sinon on le crée
									if(empty($usertemp))
									{
										$email = "change@me.eu";
										if(array_key_exists('mail', $info))
										{
											$email = $info['mail'][0];
										}
										elseif(array_key_exists('Mail', $info))
										{
											$email = $info['Mail'][0];
										}
										elseif(array_key_exists('email', $info))
										{
											$email = $info['email'][0];
										}
										elseif(array_key_exists('userprincipalname', $info))
										{
											$email = $info['userprincipalname'][0];
											if(filter_var($email,FILTER_VALIDATE_EMAIL)===FALSE)
											{
												if(filter_var($_POST['username'],FILTER_VALIDATE_EMAIL)!==FALSE)
												{
													$email=$_POST['username'];
												}
											}
										}
										
										$lg = Model_esia::getConfiguration($dbconnection,'DEFAULT_LANG');
										$q = $dbconnection->query("SELECT LOCALTIMESTAMP as time;");
										$r = $q->fetch(PDO::FETCH_OBJ);
										$usertemp = new User($dbconnection);
										$usertemp->setName($info['samaccountname'][0]);
										$usertemp->setInscriptionTime($r->time);
										$usertemp->setEmail($email);
										$usertemp->setLang($lg['DEFAULT_LANG']['value']);
										$usertemp->setHomePage("/index.php");
										$usertemp->setAuthSource(user::SRC_LDAP);
										//insertion dans la BD
										$usertemp->setGroupUser(array());
										$usertemp->setId(Model_adm::addUser($dbconnection, $usertemp));
									}
									//On met à jour les groupes auquel l'utilisateur appartient
									$group_current_member = $usertemp->getAllGroupUser();
									$diff = array_diff($group_current_member,$groups_esia_member);
									//Suppression du groupes si on a retiré des droit AD
									foreach($diff as $groupid)
									{
										Model_adm::deleteUserFromGroup($dbconnection, $usertemp->getId(),$groupid);
									}
									$diff = array_diff($groups_esia_member,$group_current_member);
									//ajout dans les groupes ESIA
									foreach($diff as $groupid)
									{
										Model_adm::addUserInGroup($dbconnection, $usertemp->getId(),$groupid);
									}
									$usertemp->setGroupUser($groups_esia_member);
									$user = $usertemp;
								}
								else 
								{
									throw new UserException("no LDAP and Esia group matching for your user");
								}
							}
							else
							{
								throw new UserException("LDAP and Esia group matching is empty");
							}
						}
						else 
						{
							throw new UserException("User not found in LDAP");
						}
						$flagauth=TRUE;
					}
					else
					{
						throw new UserException("Invalid login/password or Can't connect to LDAP");
						//exit(0);
					}
	             }
	             else
	             {
	             	throw new UserException("Can't connect to LDAP");
	             }
	        }
	        if($flagauth==FALSE)
	        {
				$user->connect($_POST['username'],$_POST['password']);
	        }
			$user->generateSessionID();
			$smarty->assign('login','1');
			$smarty->assign('l_login_success', $lang['LOGIN_SUCCESS']);
			$esialog = new EsiaLog(FILE_LOG,$_POST['username']);
			$esialog->write('ESIA', 'connection successfull');
			//on regarde pour la redirection si url est vide alors on va sur la page d'index.php
			if($user->getHomePage() != '/index.php')
			{
				if(isset($_POST['url'])&&!empty($_POST['url']))
				{
					//empềche de se faire rediriger vers /login.php
					if($_POST['url']=='/' || preg_match('#login.php#',$_POST['url']))
                    {
				        if($user->getHomePage() == null)
				        {
				        	$dashboards = Model_esia::getDashboards($dbconnection,'LANG_DASHBOARD_HOME_NEW');
				        	$smarty->assign('url', '/dashboard/default.php?id='.$dashboards[0]['id']);
				        }
				        elseif(is_numeric($user->getHomePage()))
				        {
				        	$smarty->assign('url', '/dashboard/default.php?id='.$user->getHomePage());
				        }
				        else
				        {
				        	$smarty->assign('url',$user->getHomePage());
				        }
                    }
                    else
                    {
				       $smarty->assign('url',$_POST['url']);
                    }
                }
                else
                {
				        if($user->getHomePage() == null)
				        {
				        	$smarty->assign('url','/index.php');
				        }
				        elseif(is_numeric($user->getHomePage()))
				        {
				        	$smarty->assign('url', '/dashboard/default.php?id='.$user->getHomePage());
				        }
				        else
				        {
				        	$smarty->assign('url',$user->getHomePage());
				        }
                }
			}
			else
			{
				if(isset($_POST['url'])&&!empty($_POST['url']))
				{
					//empềche de se faire rediriger vers /login.php
					if($_POST['url']=='/' || preg_match('#login.php#',$_POST['url']))
					{
						$dashboards = Model_esia::getDashboards($dbconnection,'LANG_DASHBOARD_HOME_NEW',$user->getId());
						$dashboards = array_shift($dashboards);
						$smarty->assign('url', '/dashboard/default.php?id='.$dashboards['id']);
					}
					else
					{
						$smarty->assign('url',$_POST['url']);
					}
				}
				else
				{
					$dashboards = Model_esia::getDashboards($dbconnection,'LANG_DASHBOARD_HOME_NEW',$user->getId());
					$dashboards = array_shift($dashboards);
					$smarty->assign('url', '/dashboard/default.php?id='.$dashboards['id']);
				}
			}
		}
		catch(UserException $e)
		{
			$smarty->assign('l_login_failed', $lang['LOGIN_FAILED'].' <br />'.$e->getMessage());
			sleep(3);
            if(! $_POST['url']=='/' || ! preg_match('#login.php#',$_POST['url']))
            {
                $smarty->assign('url',$_POST['url']);
            }
		}
	}
	else
	{
		header('Location: /index.php');
	}
}
$smarty->display('login.html');
?>
