<?php
/**
 * @name maintenance
 * @description script gérant l'accès au mode maintenance d'Esia
 * @author Nicolas Biersart <n.biersart@esia-sa.com>
 * @contributor
 * @copyright Nicolas Biersart 2017
 * @license
 * @esia 3.10
 * @version 3.1.0
 * @date 8/11/2017
 */
$path = $_SERVER['DOCUMENT_ROOT'];
include_once $path.'common.php';
include_once $path.'/Model_adm.php';
$temps = microtime();
$temps = explode(' ', $temps);
$debut = $temps[1] + $temps[0];
if(strpos($licence['type'],'LITE')!==FALSE)
{
	$smarty->assign('no_header', 'iframe');
	$smarty->assign('isDialog', TRUE);
	$smarty->assign('need_licence','Heimdall, Mercury');
	$smarty->display('no_licence.html');
	exit(0);
}
//
//CREATION VALEUR CONSTANTE
//
$MAINTENANCE_MODE = array('NOEXEC' => 'NOEXECUTION','EXEC' => 'NOALERT','FIRSTERROR'=>'FIRSTERROR');
$smarty->assign('MODE_MAINTENANCE',$MAINTENANCE_MODE);

$MAINTENANCE_HOUR = array();
for($i=0;$i < 24; $i++)
{
    if($i<10)
    {
        $time='0'.$i;
    }
    else
    {
         $time=$i;
    }
    $MAINTENANCE_HOUR[$time.':00']=$time.':00';
    $MAINTENANCE_HOUR[$time.':15']=$time.':15';
    $MAINTENANCE_HOUR[$time.':30']=$time.':30';
    $MAINTENANCE_HOUR[$time.':45']=$time.':45';
}
$smarty->assign('HOUR_MAINTENANCE',$MAINTENANCE_HOUR);
if(!isset($_GET['action']))
{
    $_GET['action'] ='view';
}
//
//DEBUT DE LA PAGE
//
if(isset($_GET['id']) &&is_numeric($_GET['id']) )
{
    $smarty->assign('adm_device_id',$_GET['id']);
}
elseif(isset($_POST['id'])&&is_numeric($_POST['id']) )
{
    $_GET['id'] = $_POST['id'];
}
$node = Model_esia::InstanceNode($dbconnection,$_GET['id']);
if($user->getDroits($dbconnection,"device_view",$node->getName()) ==1 && $user->getDroits($dbconnection,"esia_maintenance") == 1)
{
    if(!isset($_GET['view']))
    {
        try
        {
             $smarty->assign('action', $_GET['action']);
            //suppression
            if($_GET['action']=='delete')
            {
                if( is_numeric($_GET['planned_id']))
				{
                	Model_adm::deleteServiceMaintenancePlan($dbconnection,$_GET['planned_id']);
                	$smarty->assign('maintenance_success',$lang['MAINTENANCE_PLAN_DELETE_SUCCESS']);
				}
				elseif(is_numeric($_GET['conf_id']))
				{
					Model_adm::deleteCyclicMaintenance($dbconnection, $_GET['conf_id']);
					$smarty->assign('maintenance_success',$lang['MAINTENANCE_CYCLIC_DELETE_SUCCESS']);
				}
               	$_GET['view']='default';
               	$smarty->assign('adm_device_id',$node->getId());
            }
            elseif($_GET['action']=='next')
            {
            	if(is_numeric($_GET['conf_id']))
            	{
            		Model_adm::passNextMaintenance($dbconnection, $_GET['conf_id']);
            		$smarty->assign('maintenance_success',$lang['MAINTENANCE_CYCLIC_NEXT_SUCCESS']);
            	}
            	$_GET['view']='default';
            	$smarty->assign('adm_device_id',$node->getId());
            }
            //AJout
            elseif(isset($_POST['id'])&&is_numeric($_POST['id']) )
            {
                $start = DateTime::createFromFormat('d/m/Y H:i',$_POST['datestart'].' '.$_POST['hour']);
                $arr = array();
                $services = Model_esia::getServices($dbconnection,$node->getId());
                foreach($services as $serv)
                {
                    if(isset($_POST['maint_'.$serv['id']]))
                    {
                        $arr[] = $serv['id'];
                    }
                }
                //Ajoute le mensuel
                $select_day=null;
                $select_week=null;
                if($_POST['select_type'] == 'month')
                {
                	$_POST['interval']='1';
                	$_POST['intervalunity']='month';
                	$_POST['iscycle']='on';
                	$select_day=$_POST['selectDay'];
                	$select_week=$_POST['selectWeek'];
                	$today =  date('d/m/Y');
                	$start = DateTime::createFromFormat('d/m/Y H:i',$today.' '.$_POST['hourstarted']);
                	
                }
                else 
                {
                	$start = DateTime::createFromFormat('d/m/Y H:i',$_POST['datestart'].' '.$_POST['hour']);
                }
                //Ajout d'une nouvelle maintenance
                if(isset($_POST['iscycle']))
                {
                	
                    $during = $_POST['during'].' '.$_POST['duringunity'];
                    $interval = $_POST['interval'].' '.$_POST['intervalunity'];
                    //maintenance cyclique
                    if($_POST['mode'] =='FIRSTERROR')
                    {
                        $first = $_POST['firsterror'].' '.$_POST['firsterrorunity'];
                        Model_adm::addCyclicMaintenance($dbconnection,$arr,$_POST['mode'], $start,$during,$interval,$first, $select_week,$select_day );
                    }
                    else
                    {
                    	Model_adm::addCyclicMaintenance($dbconnection,$arr,$_POST['mode'], $start,$during,$interval,null,$select_week,$select_day  );
                    }
                }
                else
                {
                    $format='P'.$_POST['during'];
                    switch($_POST['duringunity'])
                    {
                        case 'min': $format='PT'.$_POST['during'].'M'; break;
                        case 'hour': $format='PT'.$_POST['during'].'H'; break;
                        case 'day': $format.='D';break;  
                        case 'week': $format='P'.($_POST['during']*7).'D';break;              
                        default: $format.='M';break;
                    }
                    //maintenance OneSHOT
                    $interval = new DateInterval($format);
                    $end = clone $start;
                    $end->add($interval);   
                    $first=0;                
                    if($_POST['mode'] =='FIRSTERROR')
                    {
                        $mult=1;
                        switch($_POST['firsterrorunity'])
                        {
                                case 'hour':  $mult=60; break;
                                case 'day':  $mult=60*24; break;
                                case 'week':  $mult=60*24*7; break;
                                case 'month':  $mult=60*24*7*30; break;
                                default: $mult=1; break;
                        }
                        $first = $_POST['firsterror'] * $mult;
                    }
                    Model_adm::addServiceMaintenancePlan($dbconnection,$arr,$_POST['mode'], $start,$end,$first);
                } 
                $smarty->assign('maintenance_success',$lang['MAINTENANCE_PLAN_SUCCESS']);
                $_GET['view']='default';
                $smarty->assign('adm_device_id',$node->getId());
            }
            if($_GET['action']=='nextmaintenance')
            {
                $services = Model_adm::getNextMaintenancePlan($dbconnection,null,$_GET['id']);
                $arr = array();
				$typemaintenance_inv =array_flip($MAINTENANCE_MODE);
                foreach($services as $serv)
                {
                    $common_name = Model_esia::getCommonName($lang,$serv['service_name'],$serv['plugin_name']);
                    $serv['start'] = preg_replace('#\+[0-9]*#','',$serv['start']);
                    $serv['end'] = preg_replace('#\+[0-9]*#','',$serv['end']);
                    //conversion date
                    $start = DateTime::createFromFormat ('Y-m-d H:i:s',$serv['start']);                
                    $end = DateTime::createFromFormat ('Y-m-d H:i:s',$serv['end']);   
                    $now = new DateTime();
                    $isDeletable = 1;
                    if( ($start->getTimestamp() - $now->getTimestamp()) < 660 )
                         $isDeletable = 0;
                         $arr[] =array('id'=> $serv['id'],'name'=>$serv['service_name'],'common'=>$common_name,'type'=>$MAINTENANCE_MODE[$serv['type']],'start'=>$start->format('d-m-Y H:i:s'),'end'=>$end->format('d-m-Y H:i:s'),'isdeletable' =>$isDeletable );  
                }
                $smarty->assign('service_maintenance_plan',$arr);
                $services = Model_adm::getCyclicMaintenancePlan($dbconnection,null,$_GET['id']);
                
                $arr = array();
                foreach($services as $serv)
                {
                    $common_name = Model_esia::getCommonName($lang,$serv['service_name'],$serv['plugin_name']);
                    $serv['start'] = preg_replace('#\+[0-9]*#','',$serv['start']);
                    $serv['start'] = preg_replace('#\.[0-9]*$#','',$serv['start']);
                    
                    $serv['interval'] = preg_replace('#days#',$lang['DAYS'],$serv['interval']);
                    $serv['interval'] = preg_replace('#day#',$lang['DAY'],$serv['interval']);
                    $serv['interval'] = preg_replace('#mon#',$lang['MONTH'],$serv['interval']);
                    $serv['during'] = preg_replace('#days#',$lang['DAYS'],$serv['during']);
                    $serv['during'] = preg_replace('#day#',$lang['DAYS'],$serv['during']);
                    $serv['during'] = preg_replace('#mon#',$lang['MONTH'],$serv['during']);
                    if(is_numeric( $serv['week']))
                    {
                    	$out ="";
                    	switch($serv['week'])
                    	{
                    		case 0: $out=$lang['MAINTENANCE_WEEK_FIRST']; break;
                    		case 1: $out=$lang['MAINTENANCE_WEEK_SECOND']; break;
                    		case 2: $out=$lang['MAINTENANCE_WEEK_THIRD']; break;
                    		default : $out=$lang['MAINTENANCE_WEEK_LAST']; break;
                    	}                    	
                    	switch($serv['day'])
                    	{
                    		case 0: $out.=" ".$lang['MAINTENANCE_MONDAY']; break;
                    		case 1: $out.=" ".$lang['MAINTENANCE_TUESDAY']; break;
                    		case 2: $out.=" ".$lang['MAINTENANCE_WEDNESDAY']; break;
                    		case 3: $out.=" ".$lang['MAINTENANCE_THURSDAY']; break;
                    		case 4: $out.=" ".$lang['MAINTENANCE_FRIDAY']; break;
                    		case 5: $out.=" ".$lang['MAINTENANCE_SATURDAY']; break;
                    		default : $out.=" ".$lang['MAINTENANCE_SUNDAY']; break;
                    	}
                    	$serv['interval']= $out;
                    }
                    //conversion date
                    $start = DateTime::createFromFormat ('Y-m-d H:i:s',$serv['start']);                 
                    
                    $arr[] =array('id'=> $serv['id'],
                    				'name'=>$serv['service_name'],
                    				'common'=>$common_name,
                    				'type'=>$MAINTENANCE_MODE[$serv['type']],
                    				'start'=>$start->format('d-m-Y H:i:s'),
                    				'interval'=>$serv['interval'],'during'=>$serv['during'] );  
                }
                $smarty->assign('service_cyclic_maintenance_plan',$arr);        
            }
            else
            {
                $services = Model_esia::getServices($dbconnection,$node->getId());
                $arr = array();
                foreach($services as $serv)
                {
                    $common_name = Model_esia::getCommonName($lang,$serv['name'],$serv['check_plugin_name']);
                    $arr[] =array('id'=> $serv['id'],'name'=>$serv['name'],'common'=>$common_name);
                }
                $smarty->assign('list_service',$arr);
            }
        }
        catch(EsiaDbException $e)
        {
	        //au niveux de la requête de la base de donnée cela arrive si on demande les infos d'un noeud qui n'existe pas
	        $smarty->assign('node_bad_access',$lang['NODE_NO_ACCESS']);
	        $smarty->assign('node_bad_access_1',$lang['NODE_NO_ACCESS_1']);
        }
    }
    //affiche les tabulations
    if($_GET['view']=='default')
    {
        $smarty->assign('show_menu', 'yes');
    }
}
//affichage de la page
$temps = microtime();
$temps = explode(' ', $temps);
$fin = $temps[1] + $temps[0];

// On affiche la différence entre des deux valeurs
$smarty->assign('execute_time',round(($fin - $debut),6) );

$smarty->display('maintenance.html');
?>
