<?php
namespace triggers
{

	function afterInsertMemberof(\PDO $db,int $userid,int $groupid)
	{
		$dbconnection = $db;
		$query = $dbconnection->prepare("SELECT dashboard_id FROM dashboard WHERE :groupid = ANY (dashboard_share_read_groups) ");
		$result = \Model_esia::executeStatement($query,array(':groupid'=> $groupid));
		$insert_query = "INSERT INTO public.dashboard_user_access(board_user_id, board_dashboard_id, board_user_share, board_user_access) 
								VALUES (:userid, :dashid, true, 'READ') ON CONFLICT DO NOTHING;";
		$insert_query = $dbconnection->prepare($insert_query);
		while($row=$result->fetch(\PDO::FETCH_OBJ))
		{
			$params[':userid']=$userid;
			$params[':dashid']=$row->dashboard_id;
			\Model_esia::executeStatement($insert_query,$params);
		}
		$query = $dbconnection->prepare("SELECT dashboard_id FROM dashboard WHERE :groupid = ANY (dashboard_share_write_groups) ");
		$result = \Model_esia::executeStatement($query,array(':groupid'=> $groupid));
		$insert_query = "INSERT INTO public.dashboard_user_access(board_user_id, board_dashboard_id, board_user_share, board_user_access)
								VALUES (:userid, :dashid, false, 'WRITE') ON CONFLICT DO NOTHING;";
		$insert_query = $dbconnection->prepare($insert_query);
		while($row=$result->fetch(\PDO::FETCH_OBJ))
		{
			$params[':userid']=$userid;
			$params[':dashid']=$row->dashboard_id;
			\Model_esia::executeStatement($insert_query,$params);
		}
	}
	function beforeDeleteMemberof(\PDO $db,int $userid,int $groupid)
	{
		$dbconnection = $db;
		$query = $dbconnection->prepare("SELECT dashboard_id FROM dashboard WHERE :groupid = ANY (dashboard_share_groups) ");
		$result = \Model_esia::executeStatement($query,array(':groupid'=> $groupid));
		$del_query = "DELETE FROM dashboard_user_access WHERE board_user_id=:userid AND board_dashboard_id=:dashid;";
		$del_query = $dbconnection->prepare($del_query);
		while($row=$result->fetch(\PDO::FETCH_OBJ))
		{
			$params[':userid']=$userid;
			$params[':dashid']=$row->dashboard_id;
			\Model_esia::executeStatement($del_query,$params);
		}
	}
	// $isAck = FALSE for unack
	function afterHappenErrorAck(\PDO $db, array $happenErrors, bool $isAck=TRUE)
	{
		$dbconnection = $db;
		$happenErrors = array_filter($happenErrors, 'is_numeric');
		if(empty($happenErrors))
		{
			throw new \Exception('Happen error id is missing or not a number');
		}
		// Get error response program configured in ack mode for thoses errors services
		$sql = "SELECT happen_id, program_name, program_path, response_parameter
				FROM esia_error_happen
				JOIN esia_service_response_program ON response_service_id = happen_service_id
				JOIN esia_program ON program_id = response_program_id
				WHERE response_ack IS TRUE";

		$params = array();

		$in_sql = \Model_esia::pdo_array_to_SQL('happen_id', $happenErrors, $params);
		$sql .= " AND happen_id IN ($in_sql)";

		// Get only response programs where ack mode is allowed
		if(!empty(\Model_esia::RESP_PROG_VALID_ACK))
		{
			$in_sql = \Model_esia::pdo_array_to_SQL('program_name', \Model_esia::RESP_PROG_VALID_ACK, $params);
			$sql .= " AND program_name IN ($in_sql)";
		}

		$query = $dbconnection->prepare($sql);
		$query = \Model_esia::executeStatement($query, $params);

		$programs = array();
		while($row = $query->fetch(\PDO::FETCH_OBJ))
		{
			$programs[] = array(
				'error' => $row->happen_id,
				'name' => $row->program_name,
				'path' => trim($row->program_path),
				'parameter' => trim($row->response_parameter),
			);
		}

		// Acknowledge or un-acknowledge
		if($isAck == FALSE)
		{
			$ackParam = ' -T unack';
		}
		else
		{
			$ackParam = ' -T ack';
		}

		// Exec programs with ack parameters
		foreach($programs as $prog)
		{
			$cmd = $prog['path'];
			if(!empty($prog['parameter']))
			{
				$cmd .= ' ' . preg_replace('/\$ERROR/', $prog['error'], $prog['parameter']);
			}
			$cmd .= $ackParam;

			// Exec the send script without blocking php & don't cancel the script if the web page is closed
			@shell_exec('bash -c "exec nohup setsid ' . $cmd . ' > /dev/null 2>&1 &"');
		}
	}
}
?>
